%% Music function for \retrograde. 
%% Returns music in reverse order.
retrograde =
#(define-music-function (parser location m) 
    (ly:music?)
    (retrograde-music m))

%% Music function for \modalTranspose
%% Args 'from' and 'to' have the same sense
%% as those of the normal LilyPond \transpose 
%% function.  The 'scale' argument is the scale
%% to be used for the transposition.
modalTranspose = 
#(define-music-function (parser location from to scale music) 
    (ly:music? ly:music? ly:music? ly:music?)
    (let ((transposer (make-modal-transposer from to scale)))
        (change-pitches music transposer)
        music))

%% Music function for \modalInversion
%% Arg 'around' is the pitch around which the
%% music is to be inverted, arg 'to' is the pitch
%% to which "around" will be transposed,
%% and arg 'scale' is the scale to use for the inversion.
modalInversion = 
#(define-music-function (parser location around to scale music) 
    (ly:music? ly:music? ly:music? ly:music?)
    (let ((inverter (make-modal-inverter around to scale)))
        (change-pitches music inverter)
        music)) 
                                                     

